#!/usr/bin/env python
from inspect import *
import sys
from isclassmethod import *
from isstaticmethod import *
from public import *

def isproperty(object):
    return isinstance(object,property)

@public
def getclass(object):
    """return method cls"""
    if not object: return None
    if ismodule(object): return None
    if isclass(object): return None
    if ismethod(object):
        try:
            return object.im_class # python2
        except AttributeError:
            return object.__self__ # python3

    if isproperty(object): # property
        for k,m in sys.modules.items():
            for clsname,cls in getmembers(m,isclass):
                for _,property in getmembers(cls,isproperty):
                    if property==object:
                        return cls
    if isclassmethod(object) or isstaticmethod(object):
        module = getmodule(object)
        if not module: return
        for name in dir(module):
            attr = getattr(module,name)
            if attr is None: continue
            if not isclass(attr): continue
            cls = attr
            if hasattr(cls,object.__name__):
                if object==getattr(cls,object.__name__):
                    return cls
    if hasattr(object,"__class__") and not isroutine(object):
        return object.__class__

if __name__=="__main__":
    class CLS:
        def method(self): pass
        @property
        def property(self): pass
        @classmethod
        def classmethod(cls,x): pass
        @staticmethod
        def staticmethod(x): pass
        def __str__(self): pass

    print(getclass(CLS()))
    print(getclass(CLS.method))
    print(getclass(CLS.property))
    print(getclass(CLS.classmethod))
    print(getclass(CLS.staticmethod))
    print(getclass(CLS.__str__))
    # None:
    print(getclass(CLS)) # None
    print(getclass(sys)) # None
    print(getclass(None)) # None
